$(document).ready(function(){

    $.ajax({
        url:"http://pv.sohu.com/cityjson",
        type:'get',
        dataType:"text",
        success:function (msg) {
            ip = msg.substring(19,msg.length-1);
            ip = ip.split(",");
            ip = ip[0].split(":");
            ip = ip[1].substring(2,ip[1].length - 1);
            $("#client_ip").val(ip);
        }
    })
    var name=localStorage.getItem('name');
    $("#name").val(name);
    var pwd=localStorage.getItem('pwd');
    $("#pwd").val(pwd);
    var geo=localStorage.getItem('geo');
    $("#geo").val(geo);
    var city=localStorage.getItem('city');
    $("#city").val(city);
    var selfip=localStorage.getItem('selfip');
    $("#selfip").val(selfip);

    var white=localStorage.getItem('white');
    $("#white").val(white);

    var timeout=localStorage.getItem('timeout');
    $("#timeout").val(timeout);
    var accurate=localStorage.getItem('accurate');
    if(accurate == '1'){
        $(".display_selfip").show();
        $(".display_city").hide();
        $(".display_geo").hide();

    }else{
        $(".display_selfip").hide();
        $(".display_city").show();
        $(".display_geo").show();
    }
    var accuSelect = document.getElementById("accurate");
    for(var i=0;i<accuSelect.length;i++){
        if(accuSelect[i].value==accurate)
            accuSelect[i].selected = true;
    }
    // var auth=localStorage.getItem('auth');
    // var authSelect = document.getElementById("auth");
    // for(var i=0;i<authSelect.length;i++){
    //     if(authSelect[i].value==auth)
    //         authSelect[i].selected = true;
    // }

    var agreement=localStorage.getItem('agreement');
    var agreementSelect = document.getElementById("agreement");
    for(var i=0;i<agreementSelect.length;i++){
        if(agreementSelect[i].value==agreement)
            agreementSelect[i].selected = true;
    }

    var ip_type=localStorage.getItem('ip_type');
    if(ip_type == null){
        ip_type = 1;
    }
    if(ip_type == '1'){
        $(".display_accurate").show();
        var accurate=localStorage.getItem('accurate');

        if(accurate == '1'){
            $(".display_selfip").show();
            $(".display_city").hide();
            $(".display_geo").hide();

        }else{
            $(".display_selfip").hide();
            $(".display_city").show();
            $(".display_geo").show();
        }

    }else{
        $(".display_accurate").hide();
        $(".display_city").hide();
        $(".display_geo").show();
        $(".display_selfip").hide();
    }
    var ip_typeSelect = document.getElementById("ip_type");
    for(var i=0;i<ip_typeSelect.length;i++){
        if(ip_typeSelect[i].value==ip_type)
            ip_typeSelect[i].selected = true;
    }

    var proxy_agreement=localStorage.getItem('proxy_agreement');
    if(proxy_agreement == "http"){
        proxy_agreement = "HTTP";
    }else{
        proxy_agreement = "SOCKS5";
    }
    $("#proxy_agreement").val(proxy_agreement);

    var ip=localStorage.getItem('ip');
    $("#ip").val(ip);
    var port=localStorage.getItem('port');
    $("#port").val(port);
    var proxy_ip=localStorage.getItem('proxy_ip');
    $("#proxy_ip").val(proxy_ip);
    // var proxy_user=localStorage.getItem('proxy_user');
    // if(proxy_user == "undefined"){
    //     proxy_user = "Invalid"
    // }
    // $("#proxy_user").val(proxy_user);
    // var proxy_password=localStorage.getItem('proxy_password');
    // if(proxy_password == "undefined"){
    //     proxy_password = "Invalid"
    // }
    // $("#proxy_password").val(proxy_password);


    setInterval(resetTime,1000);


});
$("#ip_type").change(function () {
    var val = $(this).val();
    if(val == '1'){
        $(".display_accurate").show();
        var accurate = $('#accurate option:selected').val();

        if(accurate == '1'){
            $(".display_selfip").show();
            $(".display_city").hide();
            $(".display_geo").hide();

        }else{
            $(".display_selfip").hide();
            $(".display_city").show();
            $(".display_geo").show();
        }

    }else{
        $(".display_accurate").hide();
        $(".display_city").hide();
        $(".display_geo").show();
        $(".display_selfip").hide();
    }
})
$("#accurate").change(function () {
    var val = $(this).val();
    if(val == '1'){
        $(".display_selfip").show();
        $(".display_city").hide();
        $(".display_geo").hide();

    }else{
        $(".display_selfip").hide();
        $(".display_city").show();
        $(".display_geo").show();
    }
})
function resetTime(){
    var time=localStorage.getItem('time');
    if(time == null){
        return;
    }
    var activeTime=localStorage.getItem('activeTime');

    var nowTime=new Date().getTime();
    time = time.substring(0,10);
    nowTime = nowTime.toString();
    nowTime = nowTime.substring(0,10);

    time = parseInt(time) + parseInt(activeTime) - parseInt(nowTime);
    var m=0;
    var s=0;
    m=Math.floor(time/60);
    m<10&&(m='0'+m);
    s=Math.floor(time%60);
    s<10&&(s='0'+s);
    if(s.length>=3){
        s = '59';
        m="0"+(Number(m)-1);
    }
    if(m.length>=3){
        m='00';
        s='00';
    }
    if(m==0 && s==0){
        $("#time").html("Invalid");
    }else{
        $("#time").html(m+":"+s);
    }

}


$("#getIp").click(function () {
    var client_ip = $("#client_ip").val();
    var name = $("#name").val();
    var pwd = $("#pwd").val();
    var geo = $("#geo").val();
    var city = $("#city").val();

    var selfip = $("#selfip").val();
    var accurate = $('#accurate option:selected').val();
    var timeout = $("#timeout").val();
    // var auth = $('#auth option:selected').val();
    var agreement = $('#agreement option:selected').val();
    var ip_type = $('#ip_type option:selected').val();
    if(ip_type == '1'){
        if(timeout > 35){
            timeout = 35;
            $("#timeout").val(35);
        }else if(timeout < 1){
            timeout = 1;
            $("#timeout").val(1);
        }
    }else{
        if(timeout > 180){
            timeout = 180;
            $("#timeout").val(180);
        }else if(timeout < 60){
            timeout = 60;
            $("#timeout").val(60);
        }
    }
    if(name == '' || pwd == ''){
        alert("Required item cannot be empty");
        return;
    }
    // if(agreement == 0 && auth == 1){
    //     alert("Socks5 does not support user authentication");
    //     return;
    // }

    $.ajax({
        url:'https://dvapi.doveproxy.net/cmapi.php?rq=distributeProxy&user='+name+'&psword='+pwd+'&geo='+geo+'&city='+city+'&selfip='+selfip+'&accurate='+accurate+"&timeout="+timeout+"&client_ip="+client_ip+"&agreement="+agreement+"&ip_type="+ip_type,
        type:'get',
        dataType:'json',
        success:function ($msg) {
            if($msg.errno != 200){
                alert($msg.msg);
            }else{
                localStorage.setItem('name',name);
                localStorage.setItem('pwd',pwd);
                localStorage.setItem('geo',geo);
                localStorage.setItem('city',city);

                localStorage.setItem('selfip',selfip);
                localStorage.setItem('accurate',accurate);
                timeout = $msg.data.timeout / 60;
                localStorage.setItem('timeout',timeout);
                // localStorage.setItem('auth',auth);
                localStorage.setItem('agreement',agreement);
                localStorage.setItem('ip_type',ip_type);



                localStorage.setItem('ip',$msg.data.ip);
                localStorage.setItem('port',$msg.data.port);
                localStorage.setItem('proxy_ip',$msg.data.d_ip);
                // localStorage.setItem('proxy_user',$msg.data.username);
                // localStorage.setItem('proxy_password',$msg.data.password);
                if(agreement == 1){
                    localStorage.setItem('proxy_agreement',"http");
                }else{
                    localStorage.setItem('proxy_agreement',"socks5");

                }
                var timestamp=new Date().getTime()
                localStorage.setItem('time',timestamp);
                localStorage.setItem('activeTime',$msg.data.timeout);
                setInterval(resetTime,1000);
                alert('Success');history.go(0);
            }
        }
    })
})

$("#apply").click(function () {
    socks5Proxy();
    alert('Success');
})
$("#cannel").click(function () {
    var name=localStorage.getItem('name');
    $("#name").val(name);
    var pwd=localStorage.getItem('pwd');
    $("#pwd").val(pwd);
    var geo=localStorage.getItem('geo');
    $("#geo").val(geo);
    var selfip=localStorage.getItem('selfip');
    $("#selfip").val(selfip);
    var accurate=localStorage.getItem('accurate');
    if(accurate == null){
        accurate=0;
    }
    $("#accurate").val(accurate);
    var auth=localStorage.getItem('auth');
    if(auth == null){
        auth=0;
    }
    $("#auth").val(auth);
    var agreement=localStorage.getItem('agreement');
    if(agreement == null){
        agreement=0;
    }
    $("#agreement").val(agreement);
    var ip=localStorage.getItem('ip');
    $("#ip").val(ip);
    var port=localStorage.getItem('port');
    $("#port").val(port);
})

$("#js-direct").click(function () {
    directProxy();
    $("li").removeClass("om-active");
    $(this).parent('li').addClass('om-active');
})
$("#js-socks5").click(function () {
    socks5Proxy();
    $("li").removeClass("om-active");
    $(this).parent('li').addClass('om-active');
})
$("#js-system").click(function () {
    sysProxy();
    $("li").removeClass("om-active");
    $(this).parent('li').addClass('om-active');
})
$("#proxy_agreement").change(function () {
    var proxy_type = $('#proxy_agreement option:selected').val();
    localStorage.setItem('proxy_agreement',proxy_type);

})
function socks5Proxy() {
    var ip=localStorage.getItem('ip');
    var port=localStorage.getItem('port');
    if(ip == undefined || port == undefined){
        alert("Please set up IP usage")
        return;
    }
    var proxy_type=localStorage.getItem('proxy_agreement');
    var white = $("#white").val();
    if(white == undefined){
        white = localStorage.getItem('white');
    }else{
        localStorage.setItem('white',white);
    }
    var byList =[];
    white = white.replace(/\ +/g,"");
    white = white.replace(/[\r\n]/g,"");
    byList = white.split(',');
    byList.push("dvapi.doveproxy.net");
    byList.push("pv.sohu.com");

    var bypassList = byList.filter(function (s) {
        return s && s.trim();
    });
    var config = {
        mode: 'fixed_servers',
        rules: {
            bypassList:bypassList
        }
    };

    config['rules']['singleProxy'] = {
        scheme: proxy_type,
        host: ip,
        port: parseInt(port)
    };
    // chrome.webRequest.onAuthRequired.addListener(
    //     callbackFn,
    //     {urls: ["<all_urls>"]},
    //     ['blocking'] );

    chrome.proxy.settings.set(
        {value: config, scope: 'regular'},
        function() {});

    iconSet('on');
}

// function callbackFn() {
//     var proxy_user=localStorage.getItem('proxy_user');
//
//     var proxy_password=localStorage.getItem('proxy_password');
//
//
//     if (proxy_password == "undefined" && proxy_user == "undefined"){
//         return {};
//
//     }
//
//     return {
//         authCredentials: {
//             username: proxy_user,
//             password: proxy_password
//         }
//     };
// }


function directProxy() {

    var config = {
        mode: 'direct',
    };

    chrome.proxy.settings.set(
        {value: config, scope: 'regular'},
        function() {});

    iconSet('off');
}
function sysProxy() {

    var config = {
        mode: 'system',
    };

    chrome.proxy.settings.set(
        {value: config, scope: 'regular'},
        function() {});

    iconSet('sys');
}
function iconSet(str) {

    var icon = {
        path: 'images/on.png',
    }
    if (str == 'off') {
        icon['path'] = 'images/off.png';
    }
    if (str == 'sys') {
        icon['path'] = 'images/sys.png';
    }
    chrome.browserAction.setIcon(icon);
}
